#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""DocString

DocString Paragraph

"""

__version__ = "$Revision$"


import os
import commands
from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord
from core.stipple import PluginBase

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'
VIM_CONFIG = os.path.expanduser("~") + "/.vimrc"

class Plugin(PluginBase):

    def __init__ (self):
        """ Function doc """
        self.name = "Vim"
        self.icon = None
        #self.vimDir = self.homePath + "/.vim"
    
    def sync(self):
        ''' get simple list of installed apps to search for config files '''
        search_string = commands.getoutput("dpkg --get-selections '*'")
        if search_string.find("vim") != -1:
            ''' write the vim config to a couchdb '''
            with open(VIM_CONFIG, 'r') as vim:
                vr = vim.read()
            print vr


            record_four = CouchRecord({  "_id"       :  "vim"   ,  
                                        "profile"   :  "user001" ,
                                        "type"      :  "dotfile" ,
                                        "file"      :  vr        ,
                                     },
                                     record_type = RECORD_TYPE)

            databaserecord = database.put_record(record_four)
            vim.close()
        else:
            print "Bash it's not even installed SUCKER!"
            return


        # the part for taring the vim directory
        #if os.path.isdir(vimdir):
        #    tar = tarfile.open(self.name.lower()+".tar", "w")
        #    tar.add(vimDir)
        #    tar.close()
        #    saveDir(vimDir)
        # maybe use https://launchpad.net/ubuntuone-storage-protocol
        
    def restore(self):
        map_js2 = 'function(doc){if (doc._id == "vim"){emit(null,doc.file);}}'
        database.add_view("vimconfig", map_js2, None, "getfile")
        result = database.execute_view("vimconfig", "getfile")

        for row in result:
            config_iter = row.value

        vim_file = open(os.path.expanduser("~") + "/.vimrc2", 'w')
        vim_file.write(config_iter)
        vim_file.close()
